#
# Credits:
#   https://medium.com/p/9e284d692d8
---

variables:
  PACKAGE_NAME: ${CI_PROJECT_NAME}
  TERRAFORM_MODULE_NAME: ${CI_PROJECT_NAME}
  TERRAFORM_TARGET_PLATFORM: ${TERRAFORM_MODULE_SYSTEM}

# ------------------------------------
# Automatically create documentation
# ------------------------------------
auto-document:
  stage: build
  image:
    name: quay.io/terraform-docs/terraform-docs:0.19.0@sha256:e7af098ff8e68a6edc7f779116ee9b125ebac8e84e092d87eed041f0cbea7815
    entrypoint: [""]
  before_script:
    - PACKAGE_SOURCE="gitlab.com/$CI_PROJECT_ROOT_NAMESPACE/$TERRAFORM_MODULE_NAME/$TERRAFORM_TARGET_PLATFORM"
  script:
    - sed -i -e 's~{{package-name}}~'"$PACKAGE_NAME"'~g' .docs/header.md
    - sed -i -e 's~{{package-source}}~'"$PACKAGE_SOURCE"'~g' .docs/header.md
    - cp -r .docs ${TERRAFORM_MODULE_DIR}/
    - terraform-docs ./${TERRAFORM_MODULE_DIR} --config ./${TERRAFORM_MODULE_DIR}/.docs/.terraform.docs.yml > ./.README.md
  artifacts:
    paths:
      - ./.README.md
    expire_in: 1 day
  allow_failure: true
  rules:
    - if: '$BOT_NAME && $CI_COMMIT_MESSAGE !~ /AUTOMATION/ && $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH && "$MIRROR" != "1"'
      exists:
        - $TERRAFORM_MODULE_DIR/*

# ------------------------------------
# Commit created documentation
# ------------------------------------
commit-documentation:
  stage: build
  image:
    name: alpine/git:v2.47.2@sha256:348f37afef018f3964ebb9490de8e26dd28a3f897e4427c1b67778a9b077360c
    entrypoint: [""]
  needs:
    - auto-document
  before_script:
    - git config --global user.email "${BOT_EMAIL}"
    - git config --global user.name "${BOT_NAME}"
  script:
    - git checkout $CI_COMMIT_REF_NAME
    - git pull
    - git status
    - mv .README.md README.md
    - git add README.md || true  # To ensure no error is thrown if there are no changes to commit.
    - git commit -m "[AUTOMATION] Update README.md" || true  # To ensure no error is thrown if there are no changes to commit.
    - git push https://$BOT_NAME:$BOT_TOKEN@$CI_SERVER_HOST/$CI_PROJECT_PATH.git HEAD:$CI_COMMIT_REF_NAME || true
    - echo "Commit successful"
  allow_failure: true
  rules:
    - if: '$BOT_NAME && $CI_COMMIT_MESSAGE !~ /AUTOMATION/ && $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH && "$MIRROR" != "1"'
      exists:
        - $TERRAFORM_MODULE_DIR/*
